#!/bin/sh
# Configuration script
-# Copyright (C) 1988, 1990, 1991 Free Software Foundation, Inc.
-
-#This file is part of GNU.
+# Copyright (C) 1988, 1990, 1991, 1992 Free Software Foundation, Inc.
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */
-# $Id$
-
# Please email any bugs, comments, and/or additions to this file to:
+# This file was written by K. Richard Pixley.
+
#
# Shell script to create proper links to machine-dependent files in
# preparation for compilation.
export PATH || (echo "OOPS, this isn't sh. Desperation time. I will feed myself to sh."; sh $0 $argv; kill $$)
-#set -e
-
remove=rm
hard_link=ln
symbolic_link='ln -s'
Makefile=Makefile
Makefile_in=Makefile.in
-ansi=
arguments=$*
-commontargets=
configdirs=
-ddestdir=
-defaulttargets=
-destdir=
+exec_prefix=
+exec_prefixoption=
fatal=
-hostsubdir=
-idestdir=
-next_ddestdir=
-next_destdir=
-next_idestdir=
-next_objdir=
+floating_point=default
+gas=default
+host_alias=
+host_makefile_frag=
+moveifchange=
+next_host=
+next_prefix=
next_site=
+next_srcdir=
next_target=
next_tmpdir=
norecursion=
-objdir=
-objdiroption=
+prefix=/usr/local
progname=
-recurring=
+program_prefix=
+program_prefixoption=
+program_suffix=
+program_suffixoption=
+program_transform_name=
+program_transform_nameoption=
+redirect=">/dev/null"
removing=
+site=
+site_makefile_frag=
+site_option=
srcdir=
srctrigger=
-target=
-targets=
-targetsubdir=
-verbose=
-version_path="yes"
+subdirs=
+target_alias=
+target_makefile_frag=
+undefinedargs=
+version="$Revision$"
+x11=default
+
+NO_EDIT="This file was generated automatically by configure. Do not edit."
+
+## this is a little touchy and won't always work, but...
+##
+## if the argv[0] starts with a slash then it is an absolute name that can (and
+## must) be used as is.
+##
+## otherwise, if argv[0] has no slash in it, we can assume that it is on the
+## path. Since PATH might include "." we also add `pwd` to the end of PATH.
+##
+
+progname=$0
+PWD=`pwd`
+
+case "${progname}" in
+/*) ;;
+*/*) ;;
+*)
+ PATH=$PATH:${PWD=`pwd`} ; export PATH
+ ;;
+esac
+
for arg in $*;
do
# handle things that might have args following as separate words
- if [ -n "${next_ddestdir}" ] ; then ddestdir=${arg} ; next_ddestdir=
- elif [ -n "${next_destdir}" ] ; then destdir=${arg} ; next_destdir= ; ddestdir=${destdir} ; idestdir=${destdir}
- elif [ -n "${next_idestdir}" ] ; then idestdir=${arg} ; next_idestdir=
- elif [ -n "${next_objdir}" ] ; then objdir=${arg} ; next_objdir=
- elif [ -n "${next_site}" ] ; then site=${arg} ; next_site=
+ if [ -n "${next_prefix}" ] ; then prefix=${arg} ; prefixoption="-prefix=${prefix}" ; next_prefix=
+ elif [ -n "${next_exec_prefix}" ] ; then
+ exec_prefix=${arg}
+ exec_prefixoption="-exec_prefix=${exec_prefix}"
+ next_exec_prefix=
+ elif [ -n "${next_site}" ] ; then site=${arg} ; site_option=-site=${site} ; next_site=
+ # remove any possible trailing slash from srcdir. See note below.
+ elif [ -n "${next_srcdir}" ] ; then srcdir=`echo ${arg} | sed -e 's:/$::'` ; next_srcdir=
+ elif [ -n "${next_program_prefix}" ] ; then
+ program_prefix=${arg}
+ program_prefixoption="-program_prefix=${program_prefix}"
+ next_program_prefix=
+ elif [ -n "${next_program_suffix}" ] ; then
+ program_suffix=${arg}
+ program_suffixoption="-program_suffix=${program_suffix}"
+ next_program_suffix=
+ elif [ -n "${next_program_transform_name}" ] ; then
+ # Double any backslashes or dollar signs in the argument
+ program_transform_name="${program_transform_name} -e `echo ${arg} | sed -e 's/\\\\/\\\\\\\\/g' -e 's/\\\$/$$/g'`"
+ program_transform_nameoption="${program_transform_nameoption} -program_transform_name='${arg}'"
+ next_program_transform_name=
elif [ -n "${next_target}" ] ; then
next_target=
- if [ -n "${targets}" ] ; then
- subdirs="+subdirs"
- fi
-
- newtargets="${targets} ${arg}"
- targets="${newtargets}"
-
+ case "${target_alias}" in
+ "")
+ target_alias="${arg}"
+ ;;
+ *)
+ echo '***' Can only configure for one target at a time. 1>&2
+ fatal=yes
+ ;;
+ esac
elif [ -n "${next_tmpdir}" ] ; then
next_tmpdir=
- tmpdiroption="+tmpdir=${arg}"
+ tmpdiroption="--tmpdir=${arg}"
TMPDIR=${arg}
else
case ${arg} in
- -ansi | +a*)
- ansi=true
- clib=clib
- ;;
- -noversion | +noversion)
- version_path="no"
+ -exec_prefix=* | --exec_prefix=* | --exec_prefi=* | --exec_pref=* | --exec_pre=* | --exec_pr=* | --exec_p=* | --exec_=* | --exec=* | --exe=* | --ex=* | --e=*)
+ exec_prefix=`echo ${arg} | sed 's/^[-a-z_]*=//'`
+ exec_prefixoption=${arg}
;;
- -ddestdir=* | +ddestdir=* | +ddestdi=* | +ddestd=* | +ddest=* | +ddes=* | +dde=* | +dd=*)
- ddestdir=`echo ${arg} | sed 's/[+-]dd[a-z]*=//'`
+ -exec_prefix | --exec_prefix | --exec_prefi | --exec_pref | --exec_pre | --exec_pr | --exec_p | --exec_ | --exec | --exe | --ex | --e)
+ next_exec_prefix=yes
;;
- -ddestdir | +ddestdir | +ddestdi | +ddestd | +ddest | +ddes | +dde | +dd)
- next_ddestdir=yes
- ;;
- -destdir=* | +destdir=* | +destdi=* | +destd=* | +dest=* | +des=* | +de=*)
- destdir=`echo ${arg} | sed 's/[+-]d[a-z]*=//'`
- ddestdir=${destdir}
- idestdir=${destdir}
- ;;
- -destdir | +destdir | +destdi | +destd | +dest | +des | +de)
- next_destdir=yes
- ;;
- -gas | +g*)
+ -gas | --g*)
gas=yes
;;
- -help | +h*)
+ -help | --he*)
fatal=true
;;
- -idestdir=* | +idestdir=* | +idestdi=* | +idestd=* | +idest=* | +ides=* | +ide=* | +id=*)
- idestdir=`echo ${arg} | sed 's/[+-]id[a-z]*=//'`
+ -host=* | --host=* | --hos=* | --ho=*)
+ case "${host_alias}" in
+ "")
+ host_alias="`echo ${arg} | sed 's/^[-a-z]*=//'`"
+ ;;
+ *)
+ echo '***' Can only configure for one host at a time. 1>&2
+ fatal=yes
+ ;;
+ esac
+ ;;
+ -nfp | --nf*)
+ floating_point=no
+ ;;
+ -norecursion | --no*)
+ norecursion=true
;;
- -idestdir | +idestdir | +idestdi | +idestd | +idest | +ides | +ide | +id)
- next_idestdir=yes
+ -prefix=* | --prefix=* | --prefi=* | --pref=* | --pre=*)
+ prefix=`echo ${arg} | sed 's/^[-a-z]*=//'`
+ prefixoption=${arg}
;;
- -languages=* | +languages=* | +language=* | +languag=* \
- | +langua=* | +langu=* | +lang=* | +lan=* | +la=* \
- | +l=*)
- languages="${languages} `echo ${arg} | sed 's/[+-]l[a-z]*=//'`"
+ -prefix | --prefix | --prefi | --pref | --pre)
+ next_prefix=yes
;;
- -nfp | +nf*)
- nfp=yes
+ -rm | --rm) removing=${arg} ;;
+ -program_prefix=* | --program_prefix=* | --program_prefi=* | --program_pref=* | --program_pre=* | --program_pr=* | --program_p=*)
+ program_prefix=`echo ${arg} | sed 's/^[-a-z_]*=//'`
+ program_prefixoption=${arg}
;;
- -norecursion | +no*)
- norecursion=true
+ -program_prefix | --program_prefix | --program_prefi | --program_pref | --program_pre | --program_pr | --program_p)
+ next_program_prefix=yes
;;
- -objdir=* | +objdir=* | +objdi=* | +objd=* | +obj=* | +ob=* | +o=*)
- objdiroption=${arg}
- objdir=`echo ${arg} | sed 's/[+-]o[a-z]*=//'`
+ -program_suffix=* | --program_suffix=* | --program_suffi=* | --program_suff=* | --program_suf=* | --program_su=* | --program_s=*)
+ program_suffix=`echo ${arg} | sed 's/^[-a-z_]*=//'`
+ program_suffixoption=${arg}
;;
- -objdir | +objdir | +objdi | +objd | +obj | +ob | +o)
- next_objdir=yes
+ -program_suffix | --program_suffix | --program_suffi | --program_suff | --program_suf | --program_su | --program_s )
+ next_program_suffix=yes
;;
- -recurring | +recurring | +recurrin | +recurri | +recurr | +recur | +recu | +rec | +re)
- recurring=true
- arguments=`echo ${arguments} | sed "s:${arg}::"`
+ -program_transform_name=* | --program_transform_name=* | --program_transform_nam=* | --program_transform_na=* | --program_transform_n=* | --program_transform_=* | --program_transform=* | --program_transfor=* | --program_transfo=* | --program_transf=* | --program_trans=* | --program_tran=* | --program_tra=* | --program_tr=* | --program_t=*)
+ # Double any \ or $ in the argument
+ program_transform_name="${program_transform_name} -e `echo ${arg} | sed -e 's/^[-a-z_]*=//' -e 's/\\\\/\\\\\\\\/g' -e 's/\\\$/$$/g'`"
+ program_transform_nameoption="${program_transform_nameoption} -program_transform_name='`echo ${arg} | sed 's/^[-a-z_]*=//'`'"
;;
- -rm | +rm)
- removing=${arg}
+ -program_transform_name | --program_transform_name | --program_transform_nam | --program_transform_na | --program_transform_n | --program_transform_ | --program_transform | --program_transfor | --program_transfo | --program_transf | --program_trans | --program_tran | --program_tra | --program_tr | --program_t)
+ next_program_transform_name=yes
;;
- -site=* | +site=* | +sit=* | +si=*)
- site=`echo ${arg} | sed 's/[+-]s[a-z]*=//'`
+ -site=* | --site=* | --sit=* | --si=*)
+ site_option=${arg}
+ site=`echo ${arg} | sed 's/^[-a-z]*=//'`
;;
- -site | +site | +sit | +si)
+ -site | --site | --sit)
next_site=yes
;;
- # -srcdir=* | +srcdir=* | +srcdi=* | +srcd=* | +src=* | +sr=*)
- # srcdir=`echo ${arg} | sed 's/[+-]s[a-z]*=//'`
- # ;;
- -subdirs | +su*)
- subdirs=${arg}
+ # remove trailing slashes. Otherwise, when the file name gets
+ # bolted into an object file as debug info, it has two slashes in
+ # it. Ordinarily this is ok, but emacs takes double slash to
+ # mean "forget the first part".
+ -srcdir=* | --srcdir=* | --srcdi=* | --srcd=* | --src=* | --sr=*)
+ srcdir=`echo ${arg} | sed 's/^[-a-z]*=//' | sed -e 's:/$::'`
;;
- -target=* | +target=* | +targe=* | +targ=* | +tar=* | +ta=*)
- if [ -n "${targets}" ] ; then
- subdirs="+subdirs"
- fi
-
- newtargets="${targets} `echo ${arg} | sed 's/[+-]t[a-z]*=//'`"
- targets="${newtargets}"
+ -srcdir | --srcdir | --srcdi | --srcd | --src | --sr)
+ next_srcdir=yes
;;
- -target | +target | +targe | +targ | +tar | +ta)
+ -target=* | --target=* | --targe=* | --targ=* | --tar=* | --ta=*)
+ case "${target_alias}" in
+ "") target_alias="`echo ${arg} | sed 's/^[-a-z]*=//'`" ;;
+ *)
+ echo '***' Can only configure for one target at a time. 1>&2
+ fatal=yes
+ ;;
+ esac
+ ;;
+ -target | --target | --targe | --targ | --tar | --ta)
next_target=yes
;;
- -tmpdir=* | +tmpdir=* | +tmpdi=* | +tmpd=* | +tmp=* | +tm=*)
+ -tmpdir=* | --tmpdir=* | --tmpdi=* | --tmpd=* | --tmp=* | --tm=*)
tmpdiroption=${arg}
- TMPDIR=`echo ${arg} | sed 's/[+-]t[a-z]*=//'`
+ TMPDIR=`echo ${arg} | sed 's/^[-a-z]*=//'`
;;
- -tmpdir | +tmpdir | +tmpdi | +tmpd | +tmp | +tm)
+ -tmpdir | --tmpdir | --tmpdi | --tmpd | --tmp | --tm)
next_tmpdir=yes
;;
- -v | -verbose | +v*)
- verbose=${arg}
+ -v | -verbose | --v)
+ redirect=
+ verbose=-v
;;
- -* | +*)
+ -version | -V | --version | --V)
+ echo "This is Cygnus Configure version" `echo ${version} | sed 's/[ $:]//g'`
+ exit 0
+ ;;
+ -x | --x) ;;
+ -* | --*)
(echo ;
echo "Unrecognized option: \"${arg}\"". ;
echo) 1>&2
fatal=true
;;
*)
- if [ -n "${hosts}" ] ; then
- subdirs="+subdirs"
- fi
-
- newhosts="${hosts} ${arg}"
- hosts=${newhosts}
+ case "${undefs}" in
+ "")
+ undefs="${arg}"
+ ;;
+ *)
+ echo '***' Can only configure for one host and one target at a time. 1>&2
+ fatal=yes
+ ;;
+ esac
;;
esac
fi
done
-if [ -n "${verbose}" ] ; then
- echo $0 $*
-fi
-
-## this is a little touchy and won't always work, but...
-##
-## if the argv[0] starts with a slash then it is an absolute name that can be
-## used as is.
-##
-## otherwise, if argv[0] has no slash in it, we can assume that it is on the
-## path. Since PATH might include "." we also add `pwd` to the end of PATH.
-##
-## otherwise we prepend `pwd` to $0 and hope that will give us an absolute
-## path.
-##
-
-if (echo $0 | grep '^/' > /dev/null) ; then
- progname=$0
-else
- if (echo $0 | grep '/' > /dev/null) ; then
- progname=`pwd`/$0
+# process host and target
+case "${fatal}" in
+"")
+# # Complain if an arg is missing
+# if [ -z "${host_alias}" ] ; then
+# (echo ;
+# echo "configure: No HOST specified." ;
+# echo) 1>&2
+# fatal=true
+# fi
+
+### This is a bit twisted.
+### * if all three are specified, this is an error.
+### * if we have neither hosts, nor unadorned args, this is an error.
+### * if no hosts are specified, then the unadorned args are hosts, but if
+### there were none, this is an error.
+### * if no targets are specified, then the unadorned args are targets, but if
+### there were no unadorned args, then the hosts are also targets.
+
+ if [ -n "${host_alias}" -a -n "${target_alias}" -a -n "${undefs}" ] ; then
+ echo '***' Can only configure for one host and one target at a time. 1>&2
+ fatal=yes
+ elif [ -z "${host_alias}" -a -z "${undefs}" ] ; then
+ echo '***' You must tell me for which host you want to configure. 1>&2
+ fatal=yes
else
- progname=$0
- PATH=$PATH:`pwd` ; export PATH
- fi
-fi
-
-configsub=`echo ${progname} | sed 's/configure$/config.sub/'`
-
-if ${configsub} none >/dev/null 2>&1 ; then
- true
-else
- echo '***' cannot find config.sub.
- echo 1
-fi
+ case "${host_alias}" in
+ "") host_alias=${undefs} ;;
+ *) ;;
+ esac
-# process host and target only if not removing.
-if [ -z "${removing}" -a -z "${fatal}" ] ; then
- # Complain if an arg is missing
- if [ -z "${hosts}" ] ; then
- (echo ;
- echo "configure: No HOST specified." ;
- echo) 1>&2
- fatal=true
+ case "${target_alias}" in
+ "")
+ case "${undefs}" in
+ "") target_alias=${host_alias} ;;
+ *) target_alias=${undefs} ;;
+ esac
+ ;;
+ *) ;;
+ esac
fi
-fi
+ ;;
+*) ;;
+esac
-if [ -n "${fatal}" -o "${hosts}" = "help" ] ; then
+if [ -n "${fatal}" -o "${host_alias}" = "help" ] ; then
(echo "Usage: configure HOST" ;
echo ;
echo "Options: [defaults in brackets]" ;
- echo " +ansi configure w/ANSI library. [no ansi lib]" ;
- echo " +ddestdir=MYDIR configure for installation host dependent files" ;
- echo " into MYDIR. [\"/usr/local\"]" ;
- echo " +idestdir=MYDIR configure for installation host independent files" ;
- echo " into MYDIR. [\"/usr/local\"]" ;
- echo " +destdir=MYDIR configure for installation of both host dependent and" ;
- echo " host independent files into MYDIR. [\"/usr/local\"]" ;
- echo " +gas configure the compilers for use with gas. [native as]" ;
- echo " +help print this message. [normal config]" ;
- echo " +lang=LANG configure to build LANG. [gcc]" ;
- echo " +nfp configure the compilers default to soft floating point. [hard float]" ;
- echo " +norecursion configure this directory only. [recurse]" ;
- echo " +objdir=ODIR configure in a parallel tree rooted in ODIR. [rooted in \".\"]" ;
- echo " +rm remove this configuration. [build a configuration]" ;
- echo " +site configure with site specific makefile" ;
-# This is correctly aligned in the output, even though it isn't here.
- echo " +subdirs configure in subdirectories. [in source directories]" ;
- echo " +target=TARGET configure for TARGET. [TARGET = HOST]" ;
- echo " +tmpdir=TMPDIR create temporary files in TMPDIR. [ TMPDIR = \"/tmp\" ]" ;
+ echo " -exec_prefix=MYDIR configure for installation of host dependent files into MYDIR. [\"/usr/local\"]" ;
+ echo " -gas configure the compilers for use with gas. [native as]" ;
+ echo " -help print this message. [normal config]" ;
+ echo " -lang=LANG configure to build LANG. [gcc]" ;
+ echo " -nfp configure the compilers default to soft floating point. [hard float]" ;
+ echo " -norecursion configure this directory only. [recurse]" ;
+ echo " -prefix=MYDIR configure for installation of host dependent files into MYDIR. [\"/usr/local\"]" ;
+ echo " -program_prefix=FOO install programs with FOO prepended to their names. [ \"\" ]" ;
+ echo " -program_suffix=FOO install programs with FOO appended to their names. [ \"\" ]" ;
+ echo " -program_transform_name=FOO install programs with names transformed by sed pattern FOO. [ \"\" ]" ;
+ echo " -site=SITE configure with site specific makefile for SITE" ;
+ echo " -srcdir=DIR find the sources in DIR. [\".\" or \"..\"]" ;
+ echo " -target=TARGET configure for TARGET. [TARGET = HOST]" ;
+ echo " -tmpdir=TMPDIR create temporary files in TMPDIR. [ TMPDIR = \"/tmp\" ]" ;
echo ;
echo "Where HOST and TARGET are something like \"vax\", \"sun3\", \"encore\", etc." ;
- echo "Asking for more than one \"+target\" implies \"+subdirs\". Any other" ;
- echo "options given will apply to all targets.") 1>&2
+ ) 1>&2
if [ -r config.status ] ; then
cat config.status
exit 1
fi
-### break up configure.in.
-if [ -r configure.in ] ; then
- if [ -z "`grep '^# per\-host:' configure.in`" ] ; then
- echo '***' `pwd`/configure.in has no "per-host:" line. 1>&2
- exit 1
- fi
+configsub=`echo ${progname} | sed 's/configure$/config.sub/'`
+moveifchange=`echo ${progname} | sed 's/configure$/move-if-change/'`
- if [ -z "`grep '^# per\-target:' configure.in`" ] ; then
- echo '***' `pwd`/configure.in has no "per-target:" line. 1>&2
- exit 1
- fi
+# this is a hack. sun4 must always be a valid host alias or this will fail.
+if ${configsub} sun4 >/dev/null 2>&1 ; then
+ true
+else
+ echo '***' cannot find config.sub. 1>&2
+ exit 1
+fi
- if [ -z "${TMPDIR}" ] ; then
- TMPDIR=/tmp ; export TMPDIR
+touch config.junk
+if ${moveifchange} config.junk config.trash ; then
+ true
+else
+ echo '***' cannot find move-if-change. 1>&2
+ exit 1
+fi
+rm -f config.junk config.trash
+
+case "${srcdir}" in
+"")
+ if [ -r configure.in ] ; then
+ srcdir=.
+ else
+ if [ -r ${progname}.in ] ; then
+ srcdir=`echo ${progname} | sed 's:/configure$::'`
+ else
+ echo '***' "Can't find configure.in. Try using -srcdir=some_dir" 1>&2
+ exit 1
+ fi
fi
+ ;;
+*) ;;
+esac
- # keep this filename short for &%*%$*# 14 char file names
- tmpfile=${TMPDIR}/cONf$$
+### warn about some conflicting configurations.
- # split configure.in into common, per-host, per-target,
- # and post-target parts. Post-target is optional.
- sed -e '/^# per\-host:/,$d' configure.in > ${tmpfile}.com
- sed -e '1,/^# per\-host:/d' -e '/^# per\-target:/,$d' configure.in > ${tmpfile}.hst
- if grep '^# post-target:' configure.in >/dev/null ; then
- sed -e '1,/^# per\-target:/d' -e '/^# post\-target:/,$d' configure.in > ${tmpfile}.tgt
- sed -e '1,/^# post\-target:/d' configure.in > ${tmpfile}.pos
- else
- sed -e '1,/^# per\-target:/d' configure.in > ${tmpfile}.tgt
- echo >${tmpfile}.pos
+case "${srcdir}" in
+".") ;;
+*)
+ if [ -f ${srcdir}/config.status ] ; then
+ echo '***' Cannot configure here in \"${PWD=`pwd`}\" when \"${srcdir}\" is currently configured. 1>&2
+ exit 1
fi
+esac
+
+# default exec_prefix
+case "${exec_prefix}" in
+"") exec_prefix="\$(prefix)" ;;
+*) ;;
+esac
+
+### break up ${srcdir}/configure.in.
+case "`grep '^# per\-host:' ${srcdir}/configure.in`" in
+"")
+ echo '***' ${srcdir}/configure.in has no "per-host:" line. 1>&2
+ exit 1
+ ;;
+*) ;;
+esac
-else
- echo '***' No configure.in in `pwd`
+case "`grep '^# per\-target:' ${srcdir}/configure.in`" in
+"")
+ echo '***' ${srcdir}/configure.in has no "per-target:" line. 1>&2
exit 1
+ ;;
+*) ;;
+esac
+
+case "${TMPDIR}" in
+"") TMPDIR=/tmp ; export TMPDIR ;;
+*) ;;
+esac
+
+# keep this filename short for &%*%$*# 14 char file names
+tmpfile=${TMPDIR}/cONf$$
+trap "rm -f ${tmpfile}.com ${tmpfile}.tgt ${tmpfile}.hst ${tmpfile}.pos" 0
+
+# split ${srcdir}/configure.in into common, per-host, per-target,
+# and post-target parts. Post-target is optional.
+sed -e '/^# per\-host:/,$d' ${srcdir}/configure.in > ${tmpfile}.com
+sed -e '1,/^# per\-host:/d' -e '/^# per\-target:/,$d' ${srcdir}/configure.in > ${tmpfile}.hst
+if grep '^# post-target:' ${srcdir}/configure.in >/dev/null ; then
+ sed -e '1,/^# per\-target:/d' -e '/^# post\-target:/,$d' ${srcdir}/configure.in > ${tmpfile}.tgt
+ sed -e '1,/^# post\-target:/d' ${srcdir}/configure.in > ${tmpfile}.pos
+else
+ sed -e '1,/^# per\-target:/d' ${srcdir}/configure.in > ${tmpfile}.tgt
+ echo >${tmpfile}.pos
fi
### do common part of configure.in
. ${tmpfile}.com
# some sanity checks on configure.in
-if [ -z "${srctrigger}" ] ; then
- echo '***' srctrigger not set in `pwd`/configure.in.
+case "${srctrigger}" in
+"")
+ echo '***' srctrigger not set in ${PWD=`pwd`}/configure.in. 1>&2
exit 1
-fi
-
-for host in ${hosts} ; do
- # Default other arg
- if [ -z "${targets}" -o -n "${defaulttargets}" ] ; then
- targets=${host}
- defaulttargets=true
- fi
-
- host_alias=${host}
-
- result=`${configsub} ${host}`
- host_cpu=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\1/'`
- host_vendor=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\2/'`
- host_os=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\3/'`
- host=${host_cpu}-${host_vendor}-${host_os}
- host_makefile_frag=config/mh-${host}
- if [ ! -f ${host_makefile_frag} ]
- then
- host_makefile_frag=config/mh-${host_alias}
+ ;;
+*) ;;
+esac
+
+result=`${configsub} ${host_alias}`
+host_cpu=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\1/'`
+host_vendor=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\2/'`
+host_os=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\3/'`
+host=${host_cpu}-${host_vendor}-${host_os}
+
+. ${tmpfile}.hst
+
+result=`${configsub} ${target_alias}`
+target_cpu=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\1/'`
+target_vendor=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\2/'`
+target_os=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\3/'`
+target=${target_cpu}-${target_vendor}-${target_os}
+
+. ${tmpfile}.tgt
+
+# Find the source files, if location was not specified.
+case "${srcdir}" in
+"")
+ srcdirdefaulted=1
+ srcdir=.
+ if [ ! -r ${srctrigger} ] ; then
+ srcdir=..
fi
+ ;;
+*) ;;
+esac
- . ${tmpfile}.hst
-
- for target in ${targets} ; do
-
- target_alias=${target}
- result=`${configsub} ${target}`
- target_cpu=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\1/'`
- target_vendor=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\2/'`
- target_os=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\3/'`
- target=${target_cpu}-${target_vendor}-${target_os}
- target_makefile_frag=config/mt-${target}
- if [ ! -f ${target_makefile_frag} ]
- then
- target_makefile_frag=config/mt-${target_alias}
- fi
-
- . ${tmpfile}.tgt
-
- hostsubdir=H-${host_alias}
- targetsubdir=T-${target_alias}
-
- if [ -n "${removing}" ] ; then
- if [ -n "${objdir}" ] ; then
- echo '***' +rm not supported for +objdir. Just \"rm -rf ${objdir}\" by hand.
- exit 1
- fi
+if [ ! -r ${srcdir}/${srctrigger} ] ; then
+ case "${srcdirdefaulted}" in
+ "") echo '***' "${progname}: Can't find ${srcname} sources in ${PWD=`pwd`}/${srcdir}" 1>&2 ;;
+ *) echo '***' "${progname}: Can't find ${srcname} sources in ${PWD=`pwd`}/. or ${PWD=`pwd`}/.." 1>&2 ;;
+ esac
- if [ -n "${subdirs}" ] ; then
- if [ -d "${hostsubdir}" ] ; then
- rm -rf ${hostsubdir}/${targetsubdir}
+ echo '***' \(At least ${srctrigger} is missing.\) 1>&2
+ exit 1
+fi
- if [ -z "`(ls ${hostsubdir}) 2>&1 | grep T- | grep -v T-independent`" ] ; then
- rm -rf ${hostsubdir}
- fi
- else
- echo Warning: no `pwd`/${hostsubdir} to remove.
- fi
- else
- rm -f ${Makefile} config.status ${links}
- fi
- else
- if [ -n "${objdir}" ]; then
- srcdir=`pwd`
- cd ${objdir}
- fi
+tooldir="\$(libdir)/${target_alias}"
- if [ -n "${subdirs}" ] ; then
- # check for existing status before allowing forced subdirs.
- if [ -f ${Makefile} ] ; then
- echo '***' "${Makefile} already exists in source directory. `pwd` not configured." 1>&2
- exit 1
- fi
+if [ "${host_alias}" != "${target_alias}" ] ; then
+ if [ "${program_prefix}" = "" ] ; then
+ if [ "${program_suffix}" = "" ] ; then
+ if [ "${program_transform_name}" = "" ] ; then
+ program_prefix=${target_alias}- ;
+ fi
+ fi
+ fi
+fi
- if [ ! -d ${hostsubdir} ] ; then mkdir ${hostsubdir} ; fi
- cd ${hostsubdir}
+# Merge program_prefix and program_suffix onto program_transform_name
+# Use a double $ so that make ignores it
+if [ "${program_suffix}" != "" ] ; then
+ program_transform_name="-e s/\$\$/${program_suffix}/ ${program_transform_name}"
+fi
- if [ ! -d ${targetsubdir} ] ; then
- if [ -z "${commontargets}" ] ; then
- mkdir ${targetsubdir}
- else
- if [ ! -d T-independent ] ; then
- mkdir T-independent
- fi
+if [ "${program_prefix}" != "" ] ; then
+ program_transform_name="-e s/^/${program_prefix}/ ${program_transform_name}"
+fi
- ${symbolic_link} T-independent ${targetsubdir}
- fi # if target independent
- fi # if no target dir yet
+for subdir in . ${subdirs} ; do
+
+ # ${subdir} is relative path from . to the directory we're currently
+ # configuring.
+ # ${invsubdir} is inverse of ${subdir), *with* trailing /, if needed.
+ invsubdir=`echo ${subdir}/ | sed -e 's|\./||g' -e 's|[^/]*/|../|g'`
+
+ ### figure out what to do with srcdir
+ case "${srcdir}" in
+ ".") # no -srcdir option. We're building in place.
+ makesrcdir=. ;;
+ /*) # absolute path
+ makesrcdir=`echo ${srcdir}/${subdir} | sed -e 's|/\.$||'`
+ ;;
+ *) # otherwise relative
+ case "${subdir}" in
+ .) makesrcdir=${srcdir} ;;
+ *) makesrcdir=`echo ${subdir} | sed -e 's:[^./][^./]*:..:g'`/${srcdir}/${subdir} ;;
+ esac
+ ;;
+ esac
+
+ if [ "${subdir}/" != "./" ] ; then
+ Makefile=${subdir}/Makefile
+ fi
+
+ if [ ! -d ${subdir} ] ; then
+ mkdir ${subdir}
+ fi
+
+ case "${removing}" in
+ "")
+ case "${subdir}" in
+ .) ;;
+ *) eval echo Building in ${subdir} ${redirect} ;;
+ esac
+
+ # FIXME Should this be done recursively ??? (Useful for e.g. gdbtest)
+ # Set up the list of links to be made.
+ # ${links} is the list of link names, and ${files} is the list of names to link to.
+
+ # Make the links.
+ configlinks="${links}"
+ if [ -r ${subdir}/config.status ] ; then
+ mv -f ${subdir}/config.status ${subdir}/config.back
+ fi
+ while [ -n "${files}" ] ; do
+ # set file to car of files, files to cdr of files
+ set ${files}; file=$1; shift; files=$*
+ set ${links}; link=$1; shift; links=$*
+
+ if [ ! -r ${srcdir}/${file} ] ; then
+ echo '***' "${progname}: cannot create a link \"${link}\"," 1>&2
+ echo '***' "since the file \"${file}\" does not exist." 1>&2
+ exit 1
+ fi
- cd ${targetsubdir}
+ ${remove} -f ${link}
+ # Make a symlink if possible, otherwise try a hard link
+ ${symbolic_link} ${srcdir}/${file} ${link} 2>/dev/null || ${hard_link} ${srcdir}/${file} ${link}
- if [ -z "${srcdir}" ] ; then
- srcdir=../..
- fi
- else
- # if not subdir builds, then make sure none exist.
- if [ -n "`(ls .) 2>&1 | (grep H- ; true)`" ] ; then
- echo '***' "Configured subdirs exist. `pwd` not configured." 1>&2
- exit 1
- else
- true
- fi
- fi
+ if [ ! -r ${link} ] ; then
+ echo '***' "${progname}: unable to link \"${link}\" to \"${srcdir}/${file}\"." 1>&2
+ exit 1
+ fi
- # Find the source files, if location was not specified.
- if [ -z "${srcdir}" ] ; then
- srcdirdefaulted=1
- srcdir=.
- if [ -n "${srctrigger}" -a ! -r ${srctrigger} ] ; then
- srcdir=..
- fi
- fi
+ echo "Linked \"${link}\" to \"${srcdir}/${file}\"."
+ done
+
+ # Create a .gdbinit file which runs the one in srcdir
+ # and tells GDB to look there for source files.
+
+ if [ -r ${srcdir}/${subdir}/.gdbinit ] ; then
+ case ${srcdir} in
+ .) ;;
+ *) cat > ${subdir}/.gdbinit <<EOF
+# ${NO_EDIT}
+dir .
+dir ${makesrcdir}
+source ${makesrcdir}/.gdbinit
+EOF
+ ;;
+ esac
+ fi
- if [ -n "${srctrigger}" -a ! -r ${srcdir}/${srctrigger} ] ; then
- if [ -z "${srcdirdefaulted}" ] ; then
- echo '***' "${progname}: Can't find ${srcname} sources in `pwd`/${srcdir}" 1>&2
- else
- echo '***' "${progname}: Can't find ${srcname} sources in `pwd`/. or `pwd`/.." 1>&2
- fi
+ # Install a makefile, and make it set VPATH
+ # if necessary so that the sources are found.
+ # Also change its value of srcdir.
+ # NOTE: Makefile generation constitutes the majority of the time in configure. Hence, this section has
+ # been somewhat optimized and is perhaps a bit twisty.
- echo '***' \(At least ${srctrigger} is missing.\) 1>&2
- exit 1
- fi
+ # code is order so as to try to sed the smallest input files we know.
- # Set up the list of links to be made.
- # ${links} is the list of link names, and ${files} is the list of names to link to.
+ # the three makefile fragments MUST end up in the resulting Makefile in this order: target, host, and site.
+ # so do these separately because I don't trust the order of sed -e expressions.
- # Make the links.
- while [ -n "${files}" ] ; do
- # set file to car of files, files to cdr of files
- set ${files}; file=$1; shift; files=$*
- set ${links}; link=$1; shift; links=$*
+ # Conditionalize for this site from "Makefile.in" (or whatever it's called) into Makefile.tem
+ rm -f ${subdir}/Makefile.tem
+ case "${site}" in
+ "") cp ${srcdir}/${subdir}/${Makefile_in} ${subdir}/Makefile.tem ;;
+ *)
+ site_makefile_frag=${srcdir}/config/ms-${site}
- if [ ! -r ${srcdir}/${file} ] ; then
- echo '***' "${progname}: cannot create a link \"${link}\"," 1>&2
- echo '***' "since the file \"${file}\" does not exist." 1>&2
- exit 1
- fi
+ if [ -f ${site_makefile_frag} ] ; then
+ sed -e "/^####/ r ${site_makefile_frag}" ${srcdir}/${subdir}/${Makefile_in} \
+ > ${subdir}/Makefile.tem
+ else
+ cp ${srcdir}/${subdir}/${Makefile_in} ${subdir}/Makefile.tem
+ site_makefile_frag=
+ fi
+ ;;
+ esac
+ # working copy now in ${subdir}/Makefile.tem
+
+ # Conditionalize the makefile for this host.
+ rm -f ${Makefile}
+ case "${host_makefile_frag}" in
+ "") mv ${subdir}/Makefile.tem ${Makefile} ;;
+ *)
+ if [ ! -f ${host_makefile_frag} ] ; then
+ host_makefile_frag=${srcdir}/${host_makefile_frag}
+ fi
+ if [ -f ${host_makefile_frag} ] ; then
+ sed -e "/^####/ r ${host_makefile_frag}" ${subdir}/Makefile.tem > ${Makefile}
+ else
+ echo '***' Expected host makefile fragment \"${host_makefile_frag}\" 1>&2
+ echo '***' is missing in ${PWD=`pwd`}. 1>&2
+ mv ${subdir}/Makefile.tem ${Makefile}
+ fi
+ esac
+ # working copy now in ${Makefile}
+
+ # Conditionalize the makefile for this target.
+ rm -f ${subdir}/Makefile.tem
+ case "${target_makefile_frag}" in
+ "") mv ${Makefile} ${subdir}/Makefile.tem ;;
+ *)
+ if [ ! -f ${target_makefile_frag} ] ; then
+ target_makefile_frag=${srcdir}/${target_makefile_frag}
+ fi
+ if [ -f ${target_makefile_frag} ] ; then
+ sed -e "/^####/ r ${target_makefile_frag}" ${Makefile} > ${subdir}/Makefile.tem
+ else
+ mv ${Makefile} ${subdir}/Makefile.tem
+ target_makefile_frag=
+ fi
+ ;;
+ esac
+ # real copy now in ${subdir}/Makefile.tem
+
+ # prepend warning about editting, and a bunch of variables.
+ rm -f ${Makefile}
+ cat > ${Makefile} <<EOF
+# ${NO_EDIT}
+VPATH = ${makesrcdir}
+links = ${configlinks}
+host_alias = ${host_alias}
+host_cpu = ${host_cpu}
+host_vendor = ${host_vendor}
+host_os = ${host_os}
+target_alias = ${target_alias}
+target_cpu = ${target_cpu}
+target_vendor = ${target_vendor}
+target_os = ${target_os}
+EOF
+ case "${target_makefile_frag}" in
+ "") ;;
+ /*)
+ echo target_makefile_frag = ${target_makefile_frag} >>${Makefile} ;;
+ *)
+ echo target_makefile_frag = ${invsubdir}${target_makefile_frag} >>${Makefile} ;;
+ esac
+
+ case "${host_makefile_frag}" in
+ "") ;;
+ /*)
+ echo host_makefile_frag = ${host_makefile_frag} >>${Makefile} ;;
+ *)
+ echo host_makefile_frag = ${invsubdir}${host_makefile_frag} >>${Makefile} ;;
+ esac
+
+ if [ "${site_makefile_frag}" != "" ] ; then
+ echo site_makefile_frag = ${invsubdir}${site_makefile_frag} >>${Makefile}
+ fi
+
+ # fixme: this shouldn't be in configure.
+ # Define macro CROSS_COMPILE in compilation if this is a cross-compiler.
+ case "${host_alias}" in
+ "${target_alias}")
+ echo "ALL=all.internal" >> ${Makefile}
+ ;;
+ *)
+ echo "CROSS=-DCROSS_COMPILE" >> ${Makefile}
+ echo "ALL=all.cross" >> ${Makefile}
+ ;;
+ esac
+
+ # reset prefix, exec_prefix, srcdir, SUBDIRS, NONSUBDIRS,
+ # remove any form feeds.
+ if [ -z "${subdirs}" ]; then
+ rm -f ${subdir}/Makefile.tem2
+ sed -e "s:^SUBDIRS[ ]*=.*$:SUBDIRS = ${configdirs}:" \
+ -e "s:^NONSUBDIRS[ ]*=.*$:NONSUBDIRS = ${noconfigdirs}:" \
+ ${subdir}/Makefile.tem > ${subdir}/Makefile.tem2
+ rm -f ${subdir}/Makefile.tem
+ mv ${subdir}/Makefile.tem2 ${subdir}/Makefile.tem
+ fi
+ sed -e "s:^prefix[ ]*=.*$:prefix = ${prefix}:" \
+ -e "s:^exec_prefix[ ]*=.*$:exec_prefix = ${exec_prefix}:" \
+ -e "s:^srcdir[ ]*=.*$:srcdir = ${makesrcdir}:" \
+ -e "s/\f//" \
+ -e "s:^program_prefix[ ]*=.*$:program_prefix = ${program_prefix}:" \
+ -e "s:^program_suffix[ ]*=.*$:program_suffix = ${program_suffix}:" \
+ -e "s:^program_transform_name[ ]*=.*$:program_transform_name = ${program_transform_name}:" \
+ -e "s:^tooldir[ ]*=.*$:tooldir = ${tooldir}:" \
+ ${subdir}/Makefile.tem >> ${Makefile}
+ # final copy now in ${Makefile}
+
+ rm -f ${subdir}/Makefile.tem
+
+ case "${host_makefile_frag}" in
+ "") using= ;;
+ *) using="and \"${host_makefile_frag}\"" ;;
+ esac
+
+ case "${target_makefile_frag}" in
+ "") ;;
+ *) using="${using} and \"${target_makefile_frag}\"" ;;
+ esac
+
+ case "${site_makefile_frag}" in
+ "") ;;
+ *) using="${using} and \"${site_makefile_frag}\"" ;;
+ esac
+
+ newusing=`echo "${using}" | sed 's/and/using/'`
+ using=${newusing}
+ echo "Created \"${Makefile}\" in" ${PWD=`pwd`} ${using}
+
+ . ${tmpfile}.pos
+
+ # describe the chosen configuration in config.status.
+ # Make that file a shellscript which will reestablish
+ # the same configuration. Used in Makefiles to rebuild
+ # Makefiles.
+
+ case "${norecursion}" in
+ "") arguments="${arguments} -norecursion" ;;
+ *) ;;
+ esac
+
+ if [ ${subdir} = . ] ; then
+ echo "#!/bin/sh
+# ${NO_EDIT}
+# This directory was configured as follows:
+${progname}" ${arguments} "
+# ${using}" > ${subdir}/config.new
+ else
+ echo "#!/bin/sh
+# ${NO_EDIT}
+# This directory was configured as follows:
+cd ${invsubdir}
+${progname}" ${arguments} "
+# ${using}" > ${subdir}/config.new
+ fi
+ chmod a+x ${subdir}/config.new
+ if [ -r ${subdir}/config.back ] ; then
+ mv -f ${subdir}/config.back ${subdir}/config.status
+ fi
+ ${moveifchange} ${subdir}/config.new ${subdir}/config.status
+ ;;
- ${remove} -f ${link}
- rm -f config.status
- # Make a symlink if possible, otherwise try a hard link
- ${symbolic_link} ${srcdir}/${file} ${link} 2>/dev/null || ${hard_link} ${srcdir}/${file} ${link}
+ *) rm -f ${Makefile} ${subdir}/config.status ${links} ;;
+ esac
+done
- if [ ! -r ${link} ] ; then
- echo '***' "${progname}: unable to link \"${link}\" to \"${srcdir}/${file}\"." 1>&2
- exit 1
- fi
+# If there are subdirectories, then recur.
+if [ -z "${norecursion}" -a -n "${configdirs}" ] ; then
+ for configdir in ${configdirs} ; do
+ eval echo Configuring ${configdir}... ${redirect}
- if [ -n "${verbose}" ] ; then
- echo "Linked \"${link}\" to \"${srcdir}/${file}\"."
+ if [ -d ${srcdir}/${configdir} ] ; then
+ case "${srcdir}" in
+ ".") ;;
+ *)
+ if [ ! -d ./${configdir} ] ; then
+ mkdir ./${configdir}
fi
- done
+ ;;
+ esac
- # Create a .gdbinit file which runs the one in srcdir
- # and tells GDB to look there for source files.
+ POPDIR=${PWD=`pwd`}
+ cd ${configdir}
- case ${srcdir} in
- .)
+### figure out what to do with srcdir
+ case "${srcdir}" in
+ ".") newsrcdir=${srcdir} ;; # no -srcdir option. We're building in place.
+ /*) # absolute path
+ newsrcdir=${srcdir}/${configdir}
+ srcdiroption="-srcdir=${newsrcdir}"
;;
- *)
- echo "dir ." > .gdbinit
- echo "dir ${srcdir}" >> .gdbinit
- echo "source ${srcdir}/.gdbinit" >> .gdbinit
+ *) # otherwise relative
+ newsrcdir=../${srcdir}/${configdir}
+ srcdiroption="-srcdir=${newsrcdir}"
;;
esac
- # Install a makefile, and make it set VPATH
- # if necessary so that the sources are found.
- # Also change its value of srcdir.
-
- # FIXME-someday: This business of always writing to .tem and mv back
- # is so that I don't screw things up while developing. Once this
- # template is stable, these should be optimized. xoxorich.
-
- # Define macro CROSS_COMPILE in compilation if this is a cross-compiler.
- if [ "${host}" != "${target}" ] ; then
- echo "CROSS=-DCROSS_COMPILE" > ${Makefile}
- echo "ALL=start.encap" >> ${Makefile}
- else
- echo "ALL=all.internal" > ${Makefile}
- fi
-
- # set target, host, VPATH
- echo "host_alias = ${host_alias}" >> ${Makefile}
- echo "host_cpu = ${host_cpu}" >> ${Makefile}
- echo "host_vendor = ${host_vendor}" >> ${Makefile}
- echo "host_os = ${host_os}" >> ${Makefile}
-
- echo "target_alias = ${target_alias}" >> ${Makefile}
- echo "target_cpu = ${target_cpu}" >> ${Makefile}
- echo "target_vendor = ${target_vendor}" >> ${Makefile}
- echo "target_os = ${target_os}" >> ${Makefile}
-
- if [ -n "${subdirs}" ] ; then
- (echo "subdir = /${hostsubdir}/${targetsubdir}" ;
- echo "unsubdir = ../..") >> ${Makefile}
- else
- (echo "subdir =" ;
- echo "unsubdir = .") >> ${Makefile}
- fi
-
- # echo "workdir = `pwd`" >> ${Makefile}
- echo "VPATH = ${srcdir}" >> ${Makefile}
-
- # add "Makefile.in" (or whatever it's called)
- cat ${srcdir}/${Makefile_in} >> ${Makefile}
-
- # Conditionalize the makefile for this site.
- if [ -n "${site}" ] ; then
- site_makefile_frag=config/ms-${site}
-
- if [ -f ${srcdir}/${site_makefile_frag} ] ; then
- (echo "site_makefile_frag = ${srcdir}/${site_makefile_frag}" ;
- sed -e "/^####/ r ${srcdir}/${site_makefile_frag}" ${Makefile}) > Makefile.tem
- else
- (echo "site_makefile_frag =" ;
- cat ${Makefile}) > Makefile.tem
- fi
- mv Makefile.tem ${Makefile}
- fi
-
- # Conditionalize the makefile for this host.
- if [ -f ${srcdir}/${host_makefile_frag} ] ; then
- (echo "host_makefile_frag = ${srcdir}/${host_makefile_frag}" ;
- sed -e "/^####/ r ${srcdir}/${host_makefile_frag}" ${Makefile}) > Makefile.tem
+### check for guested configure, otherwise fix possibly relative progname
+ if [ -f ${newsrcdir}/configure ] ; then
+ recprog=${newsrcdir}/configure
else
- (echo "host_makefile_frag =" ;
- cat ${Makefile}) > Makefile.tem
+ case "${progname}" in
+ /*) recprog=${progname} ;;
+ *) recprog=../${progname} ;;
+ esac
fi
- mv Makefile.tem ${Makefile}
- # Conditionalize the makefile for this target.
- if [ -f ${srcdir}/${target_makefile_frag} ] ; then
- (echo "target_makefile_frag = ${srcdir}/${target_makefile_frag}" ;
- sed -e "/^####/ r ${srcdir}/${target_makefile_frag}" ${Makefile}) > Makefile.tem
+### The recursion line is here.
+ if eval ${recprog} ${verbose} ${host_alias} -target=${target_alias} \
+ ${prefixoption} ${tmpdiroption} ${exec_prefixoption} \
+ ${srcdiroption} ${program_prefixoption} ${program_suffixoption} ${program_transform_nameoption} ${site_option} ${removing} ${redirect} ; then
+ true
else
- (echo "target_makefile_frag =" ;
- cat ${Makefile}) > Makefile.tem
- fi
- mv Makefile.tem ${Makefile}
-
- # set srcdir
- sed "s@^srcdir = \.@srcdir = ${srcdir}@" ${Makefile} > Makefile.tem
- mv Makefile.tem ${Makefile}
-
- # set ddestdir
- if [ -n "${ddestdir}" ] ; then
- sed "s:^ddestdir =.*$:ddestdir = ${ddestdir}:" ${Makefile} > Makefile.tem
- mv Makefile.tem ${Makefile}
- fi
-
- # set idestdir
- if [ -n "${idestdir}" ] ; then
- sed "s:^idestdir =.*$:idestdir = ${idestdir}:" ${Makefile} > Makefile.tem
- mv Makefile.tem ${Makefile}
- fi
-
- # reset SUBDIRS
- sed "s:^SUBDIRS =.*$:SUBDIRS = ${configdirs}:" ${Makefile} > Makefile.tem
- mv Makefile.tem ${Makefile}
-
- # reset NONSUBDIRS
- sed "s:^NONSUBDIRS =.*$:NONSUBDIRS = ${noconfigdirs}:" ${Makefile} > Makefile.tem
- mv Makefile.tem ${Makefile}
-
- # remove any form feeds.
- sed -e "s/\f//" ${Makefile} > Makefile.tem
- mv Makefile.tem ${Makefile}
-
- using=
- if [ -f ${srcdir}/${host_makefile_frag} ] ; then
- using="${using} and \"${host_makefile_frag}\""
- fi
- if [ -f ${srcdir}/${target_makefile_frag} ] ; then
- using="${using} and \"${target_makefile_frag}\""
- fi
- if [ -n "${site}" -a \
- -f ${srcdir}/${site_makefile_frag} ] ; then
- using="${using} and \"${site_makefile_frag}\""
- fi
- using=`echo "${using}" | sed 's/and/using/'`
- using="Created \"${Makefile}\" in `pwd`${using}."
-
- if [ -n "${verbose}" -o -z "${recurring}" ] ; then
- echo ${using}
+ exit 1
fi
- . ${tmpfile}.pos
-
- # describe the chosen configuration in config.status.
- # Make that file a shellscript which will reestablish
- # the same configuration. Used in Makefiles to rebuild
- # Makefiles.
-
- echo "#!/bin/sh
-# `pwd` was configured as follows:
-(cd ${srcdir} ; ${progname}" ${arguments} `if [ -z "${norecursion}" ] ; then echo +norecursion ; else true ; fi` ")
-# ${using}" > config.status
- chmod a+x config.status
-
- originaldir=`pwd`
- cd ${srcdir}
- fi
-
- # If there are subdirectories, then recurse.
- if [ -z "${norecursion}" -a -n "${configdirs}" ] ; then
- for configdir in ${configdirs} ; do
- if [ -n "${verbose}" ] ; then
- echo Configuring ${configdir}...
- fi
-
- if [ -d ${configdir} ] ; then
- if [ -n "${objdir}" ] ; then
- if [ ! -d ${objdir}/${configdir} ] ; then
- mkdir ${objdir}/${configdir}
- fi
- fi
-
- POPDIR=`pwd`
- cd ${configdir}
-
- if (${progname} +recurring ${host_alias} +target=${target_alias} \
- ${verbose} ${subdirs} ${removing} +ddestdir=${ddestdir} +idestdir=${idestdir} \
- `if [ -n "${objdir}" ] ; then echo +objdir=${objdir}/${configdir} ; fi` \
- ${tmpdiroption}) ; then
- true
- else
- exit 1
- fi
-
- cd ${POPDIR}
-
-# (cd ${configdir} ;
-# if (${progname} +recurring ${host_alias} +target=${target_alias} \
-# ${verbose} ${subdirs} ${removing} +destdir=${destdir} \
-# `if [ -n "${objdir}" ] ; then echo +objdir=${objdir}/${configdir} ; fi` \
-# ${tmpdiroption}) ; then true ; else exit 1 ; fi) \
-# | sed 's/^/ /'
- else
- if [ -n "${verbose}" ] ; then
- echo Warning: directory \"${configdir}\" is missing.
- fi
- fi
- done
- fi
- done # for each target
-
- # Now build a Makefile for this host.
- if [ -n "${subdirs}" -a ! -n "${removing}" ] ; then
- push=`pwd`
-
- if [ -n "${objdir}" ] ; then
- cd ${objdir}
+ cd ${POPDIR}
+ else
+ eval echo Warning: source directory \"${srcdir}/${configdir}\" is missing. ${redirect}
fi
-
- cd ${hostsubdir}
- cat > GNUmakefile << 'E!O!F'
-# Makefile generated by configure for host ${host_alias}.
-
-ALL := $(shell ls -d T-*)
-
-%:
- $(foreach subdir,$(ALL),$(MAKE) -C $(subdir) \$@ &&) true
-
-all:
-E!O!F
- cd ${push}
- fi
-done # for each host
-
-### clean up.
-
-rm -f ${tmpfile}.com ${tmpfile}.tgt ${tmpfile}.hst ${tmpfile}.pos
+ done
+fi
exit 0
-#
-#
-# $Log$
-# Revision 1.70 1991/11/13 19:49:17 sac
-# The +noversion flag will make an installation happen to the machine/..
-# directory rather than the machine/version/.. directory.
-#
-# Steve
-#
-# Revision 1.69 1991/11/12 04:41:21 rich
-# allow +foo bar options. stolen from texinfo configure
-#
-# Revision 1.68 1991/11/09 11:34:52 rich
-# correct a comment
-#
-# Revision 1.67 1991/11/06 22:28:08 rich
-# pass +idestdir and +ddestdir
-#
-# Revision 1.66 1991/11/05 04:02:14 rich
-# don't allow +recurring to reach config.status
-#
-# Revision 1.65 1991/11/01 00:25:28 rich
-# new install theme
-#
-# Revision 1.64 1991/10/30 06:55:25 rich
-# suck in site makefile frags first
-#
-# Revision 1.63 1991/10/25 02:07:18 steve
-# More name changing
-#
-# Revision 1.62 1991/10/24 11:59:03 rich
-# add null definitions for makefile_frag_foo
-#
-# Revision 1.61 1991/10/24 00:23:59 hgs
-# Allow for using tmake-sun4
-#
-# Revision 1.60 1991/10/23 21:48:28 rich
-# Makefiles should include the makefile frag names even if the makefile
-# frag doesn't exist in *this* directory. Otherwise we inherit the
-# variable setting from our parent Makefile.
-#
-# Revision 1.59 1991/10/16 19:53:31 gnu
-# Update for SCO problems.
-#
-# * Fix "Larry Wall kludge" line so it works. If this script is run by csh,
-# it will complain, feed itself to sh, and complain some more. But will work.
-#
-# * Use <14 char file names in /tmp.
-#
-# Revision 1.58 1991/10/16 06:12:52 rich
-# Two small bugs. First, single quoted sed line doesn't need to quote
-# '$'. Second, use quotes around the hereis document trigger in order
-# to quote the entire contents of the hereis document.
-#
-# Revision 1.57 1991/10/11 05:31:05 gnu
-# Simplify "Using" message code. Put the message that configure prints
-# (or suppresses) into the config.status file as a comment.
-#
-# Revision 1.56 1991/10/10 05:01:47 rich
-# Remove the set -e but protect the recusion call.
-#
-# Revision 1.55 1991/10/10 04:57:23 rich
-# * Die when sub-configure's do.
-# * get the makefile building message line correct.
-# * set -e
-#
-# Revision 1.54 1991/10/10 01:04:42 rich
-# Backed out the "/bin/sh config.sub" change. Fails when config.sub was
-# on PATH.
-#
-# Revision 1.53 1991/10/10 00:38:08 rich
-# Call config.sub as "/bin/sh config.sub" instead of directly. This
-# protects us from the case where config.sub isn't executable.
-#
-# Revision 1.52 1991/10/09 00:48:26 rich
-# Another patch from jim.
-#
-# Revision 1.51 1991/10/08 06:07:58 wilson
-# Fix bug in smake- file code.
-#
-# Revision 1.50 1991/10/04 23:49:37 rich
-# Per's patch for my config.sub botch.
-#
-# Revision 1.49 1991/10/04 22:52:09 rich
-# Use john's heuristic for finding ourselves. kinda like hare krishna.
-#
-# Revision 1.48 1991/10/02 13:17:28 rich
-# take out the set -e for now
-#
-# Revision 1.47 1991/10/02 10:02:23 rich
-# * temporary files in TMPDIR
-# * +objdir
-#
-# Revision 1.46 1991/10/02 06:29:53 rich
-# Added +site=foo option for naming site specific Makefile fragments.
-#
-# Revision 1.45 1991/10/02 06:15:13 rich
-# Removed +f option. Used to stand for +forcesubdirs which is now
-# called +subdirs.
-#
-# Revision 1.44 1991/10/02 06:02:35 rich
-# Added rcs log line.
-#
-#
-#
-
#
# Local Variables:
# fill-column: 131